package recommendation.main;
import java.util.ArrayList;
import java.util.List;



public class Recommender {
	
	public String userID;
	public ArrayList<RecommendationList> recommendationList;
	public ArrayList<RecommendationList> userHistory;
	public String workspace; //yeni
	public Recommender(String id)
	{
			userID = id;
			recommendationList = new ArrayList<>();
			userHistory = new ArrayList<>();
			
	}
	public Recommender()
	{
			
	}
	public void getRecommendation() throws Exception
	{
		Neo4jclass network = new Neo4jclass();
		network.setWorkspace(workspace);
		network.start();
		network.findNeigbor(userID, recommendationList );
	//	network.findHistory(userID, userHistory);
		network.graphDB.shutdown();
		
	}
	public void train(String argedorDataFolderPath, String workspacePath) //her mainde cagirilmasi lazim!!
	{
		workspace = workspacePath;
		Neo4jclass database = new Neo4jclass();
		database.startAtBeginning(argedorDataFolderPath,workspacePath); 
		database.graphDB.shutdown();
	}
	public void loadWorkspace(String workspacePath) 
	{
		workspace = workspacePath;
		
	}
	public List<Long> recommend(Long userId ) throws Exception{
		List<Long> recommendations = new ArrayList<Long>();
		
		userID = Long.toString(userId); //not sure
	//	System.out.println("userID="+userID);
		recommendationList = new ArrayList<>();
		userHistory = new ArrayList<>();
		getRecommendation();
		if(recommendationList.size() == 0) 
		{
			
			System.out.println("getRecommendation returns Empty");
		}
		for (int i=0;i<recommendationList.size();i++) 
		{
			
			Long id = Long.parseLong(recommendationList.get(i).songID);
			recommendations.add(id);
		}
		return recommendations;
	}
//	public static void main(String argv[])
//	{
//		Recommender r = new Recommender("2062192");
//		r.getRecommendation();
//	}
/*	public static void main(String argv[]) throws Exception 
	{
		Long user = 1001929L;
		String workS= "C:\\Users\\isinsukatircioglu\\workspace\\RecommendationSystem\\db\\graphDB";
		List<Long> results = new ArrayList<Long>();
		Recommender r = new Recommender();
		//r.train("asd", "C:\\Users\\user\\workspace2\\RecommendationSystem\\db\\graphDB2");
		r.loadWorkspace(workS);
		results.addAll(r.recommend(user));
		if(results.size()==0) 
		{
			System.out.println("Empty results");
		}
		for(int i=0;i<results.size();i++) 
		{
			
			System.out.println(results.get(i));
		}
	}*/

}
